package resolver

// This file will be automatically regenerated based on the schema, any resolver implementations
// will be copied through when generating and any unknown code will be moved to the end.
// Code generated by github.com/99designs/gqlgen version v0.17.40

import (
	"context"
	"fmt"

	_map "gitlab.com/talgat.s/belka-go/graph/map"
	"gitlab.com/talgat.s/belka-go/graph/model"
	"gitlab.com/talgat.s/belka-go/graph/scalar"
	"gitlab.com/talgat.s/belka-go/internal/game"
)

// OnGameStart is the resolver for the onGameStart field.
func (r *subscriptionResolver) OnGameStart(ctx context.Context, gameID string) (<-chan *model.Game, error) {
	r.Log.InfoContext(ctx, "start subscription OnGameStart", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnGameStart",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnGameStart",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnGameStart(make(chan game.Game))

	msg := make(chan *model.Game)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnGameStart")
				return
			case g := <-r.Games[gameID].GetSub().GetOnGameStart():
				msg <- _map.GameGameToGame(g)
			}
		}
	}()

	return msg, nil
}

// OnPlayersSuitChange is the resolver for the onPlayersSuitChange field.
func (r *subscriptionResolver) OnPlayersSuitChange(ctx context.Context, gameID string) (<-chan []*model.PlayerSuit, error) {
	r.Log.InfoContext(ctx, "start subscription OnPlayersSuitChange", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnPlayersSuitChange",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnPlayersSuitChange",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnPlayersSuitChange(make(chan map[game.Player]game.Suit))

	msg := make(chan []*model.PlayerSuit)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnPlayersSuitChange")
				return
			case ps := <-r.Games[gameID].GetSub().GetOnPlayersSuitChange():
				msg <- _map.GamePlayersSuitToPlayersSuit(ps)
			}
		}
	}()

	return msg, nil
}

// OnScoresChange is the resolver for the onScoresChange field.
func (r *subscriptionResolver) OnScoresChange(ctx context.Context, gameID string) (<-chan []*model.TeamScore, error) {
	r.Log.InfoContext(ctx, "start subscription OnScoresChange", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnScoresChange",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnScoresChange",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnScoresChange(make(chan game.TeamsScore))

	msg := make(chan []*model.TeamScore)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnScoresChange")
				return
			case ts := <-r.Games[gameID].GetSub().GetOnScoresChange():
				msg <- _map.GameTeamsScoreToTeamsScore(ts)
			}
		}
	}()

	return msg, nil
}

// OnGameEnd is the resolver for the onGameEnd field.
func (r *subscriptionResolver) OnGameEnd(ctx context.Context, gameID string) (<-chan *model.Game, error) {
	r.Log.InfoContext(ctx, "start subscription OnGameEnd", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnGameEnd",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnGameEnd",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnGameEnd(make(chan game.Game))

	msg := make(chan *model.Game)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnGameEnd")
				return
			case g := <-r.Games[gameID].GetSub().GetOnGameEnd():
				msg <- _map.GameGameToGame(g)
			}
		}
	}()

	return msg, nil
}

// OnRoundStart is the resolver for the onRoundStart field.
func (r *subscriptionResolver) OnRoundStart(ctx context.Context, gameID string) (<-chan *model.Round, error) {
	r.Log.InfoContext(ctx, "start subscription OnRoundStart", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnRoundStart",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnRoundStart",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnRoundStart(make(chan game.Round))

	msg := make(chan *model.Round)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnRoundStart")
				return
			case r := <-r.Games[gameID].GetSub().GetOnRoundStart():
				msg <- _map.GameRoundToRound(r)
			}
		}
	}()

	return msg, nil
}

// OnTrumpSuitChange is the resolver for the onTrumpSuitChange field.
func (r *subscriptionResolver) OnTrumpSuitChange(ctx context.Context, gameID string) (<-chan scalar.Suit, error) {
	r.Log.InfoContext(ctx, "start subscription OnTrumpSuitChange", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnTrumpSuitChange",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnTrumpSuitChange",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnTrumpSuitChange(make(chan game.Suit))

	msg := make(chan scalar.Suit)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnTrumpSuitChange")
				return
			case s := <-r.Games[gameID].GetSub().GetOnTrumpSuitChange():
				msg <- _map.GameSuitToSuit(s)
			}
		}
	}()

	return msg, nil
}

// OnHandsChange is the resolver for the onHandsChange field.
func (r *subscriptionResolver) OnHandsChange(ctx context.Context, gameID string) (<-chan []*model.Hand, error) {
	r.Log.InfoContext(ctx, "start subscription OnHandsChange", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnHandsChange",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnHandsChange",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnHandsChange(make(chan map[game.Player]*game.Hand))

	r.Log.InfoContext(ctx, "listen for OnHandsChange", "gameID", gameID)

	msg := make(chan []*model.Hand)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnHandsChange")
				return
			case hs := <-r.Games[gameID].GetSub().GetOnHandsChange():
				msg <- _map.GamePlayersHandToPlayerHands(hs)
			}
		}
	}()

	return msg, nil
}

// OnRoundEnd is the resolver for the onRoundEnd field.
func (r *subscriptionResolver) OnRoundEnd(ctx context.Context, gameID string) (<-chan *model.Round, error) {
	r.Log.InfoContext(ctx, "start subscription OnRoundEnd", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnRoundEnd",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnRoundEnd",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnRoundEnd(make(chan game.Round))

	msg := make(chan *model.Round)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnRoundEnd")
				return
			case r := <-r.Games[gameID].GetSub().GetOnRoundEnd():
				msg <- _map.GameRoundToRound(r)
			}
		}
	}()

	return msg, nil
}

// OnLapStart is the resolver for the onLapStart field.
func (r *subscriptionResolver) OnLapStart(ctx context.Context, gameID string) (<-chan *model.Lap, error) {
	r.Log.InfoContext(ctx, "start subscription OnLapStart", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnLapStart",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnLapStart",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnLapStart(make(chan game.Lap))

	msg := make(chan *model.Lap)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnLapStart")
				return
			case l := <-r.Games[gameID].GetSub().GetOnLapStart():
				msg <- _map.GameLapToLap(l)
			}
		}
	}()

	return msg, nil
}

// OnLapEnd is the resolver for the onLapEnd field.
func (r *subscriptionResolver) OnLapEnd(ctx context.Context, gameID string) (<-chan *model.Lap, error) {
	r.Log.InfoContext(ctx, "start subscription OnLapEnd", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnLapEnd",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnLapEnd",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnLapEnd(make(chan game.Lap))

	msg := make(chan *model.Lap)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnLapEnd")
				return
			case l := <-r.Games[gameID].GetSub().GetOnLapEnd():
				msg <- _map.GameLapToLap(l)
			}
		}
	}()

	return msg, nil
}

// OnMoveStart is the resolver for the onMoveStart field.
func (r *subscriptionResolver) OnMoveStart(ctx context.Context, gameID string) (<-chan *model.Move, error) {
	r.Log.InfoContext(ctx, "start subscription OnMoveStart", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnMoveStart",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnMoveStart",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnMoveStart(make(chan game.Move))

	msg := make(chan *model.Move)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnMoveStart")
				return
			case m := <-r.Games[gameID].GetSub().GetOnMoveStart():
				msg <- _map.GameMoveToMove(m)
			}
		}
	}()

	return msg, nil
}

// OnMoveEnd is the resolver for the onMoveEnd field.
func (r *subscriptionResolver) OnMoveEnd(ctx context.Context, gameID string) (<-chan *model.Move, error) {
	r.Log.InfoContext(ctx, "start subscription OnMoveEnd", "gameID", gameID)

	if r.Games[gameID] == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnMoveEnd",
			"error", fmt.Errorf("game %s does not exists", gameID),
		)
		return nil, fmt.Errorf("no game with id %s, please contact developers", gameID)
	}

	if r.Games[gameID].GetSub() == nil {
		r.Log.ErrorContext(
			ctx,
			"fail subscription OnMoveEnd",
			"error", fmt.Errorf("game %s does not have subscriptions", gameID),
		)
		return nil, fmt.Errorf("no subscription for game with id %s, please contact developers", gameID)
	}

	r.Games[gameID].GetSub().SetOnMoveEnd(make(chan game.Move))

	msg := make(chan *model.Move)

	go func() {
		for {
			select {
			case <-ctx.Done():
				close(msg)
				r.Log.InfoContext(ctx, "end subscription OnMoveEnd")
				return
			case m := <-r.Games[gameID].GetSub().GetOnMoveEnd():
				msg <- _map.GameMoveToMove(m)
			}
		}
	}()

	return msg, nil
}
